DGROUP	GROUP	DATA
DATA	SEGMENT	WORD PUBLIC 'DATA'
	ASSUME	DS:DATA
;The size of this string may be changed to suit one's needs.
str	db 1024 dup(?)
DATA	ENDS
PGROUP GROUP	PROG
PROG	SEGMENT	BYTE	PUBLIC 'PROG'
	PUBLIC	CLS,BEEP,HOME,CURPOS,STCPY,STLEN,STCAT,NDX
	ASSUME CS:PGROUP
;clear the screen function. usage: cls();
CLS	PROC	NEAR
	PUSH	BP
    MOV AH,6     ;this specifys we want a scroll
                 ;CH/CL specifies row & column
                 ;scroll region's upper left corner
    MOV CH,0     ;row = 0
    MOV CL,0     ;column = 0
                 ;DH/DL does the same for lower
                 ;right corner.
    MOV DH,24    ;row = 24
    MOV DL,79    ;column = 79                 ;BH specifies color to fill with
    MOV BH,7     ;we'll use black
                 ;AL specifies how far to scroll
    MOV AL,0     ;0 means blank out entire region
    INT 16       ;call video_io

    MOV AH,2     ;position cursor function
                 ;DH/DL specifies row and column
    MOV DH,0     ;row = 0
    MOV DL,0     ;column = 0
                 ;BH specifies which display page
    MOV BH,0     ;page 0
    INT 16       ;call video_io
	POP	BP
	RET	;RETURN TO CALLER
CLS	ENDP
;make a short beep on speaker. usage beep();
BEEP	PROC	NEAR
	PUSH	BP
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	DI
	CLI
	MOV	DI,3000
	MOV	BX,25
	MOV	AL,0B6H
	OUT	43H,AL
	MOV	DX,14H
	MOV	AX,4F38H
	DIV	DI
	OUT	42H,AL
	MOV	AL,AH
	OUT	42H,AL
	IN	AL,61H
	MOV	AH,AL
	OR	AL,3
	OUT	61H,AL
WAIT:	MOV	CX,2801
SPKR_ON:	LOOP SPKR_ON
	DEC	BX
	JNZ	WAIT
	MOV	AL,AH
	OUT	61H,AL
	POP	DI
	POP	DX
	POP	CX
	POP	BX
	POP 	AX
	POP 	BP
	STI
	RET
BEEP	ENDP
;home the cursor [ cls() automatically does this]. usage: home();
HOME	PROC	NEAR
	PUSH	BP
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	DI
    MOV AH,2     ;position cursor function
                 ;DH/DL specifies row and column
    MOV DH,0     ;row = 0
    MOV DL,0     ;column = 0
                 ;BH specifies which display page
    MOV BH,0     ;page 0
    INT 16       ;call video_io
	POP	DI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	BP
	RET	;RETURN TO CALLER
HOME	ENDP
;position the cursor on screen. usage: curpos(row, col);
CURPOS	PROC	NEAR
	PUSH	BP
	MOV	BP,SP
	MOV	DX,[BP + 4]	;GET ROW POSITION
	MOV	CX,[BP + 6]	;GET COL POSITION
	MOV	DH,DL		;ROW TO DH
	MOV	DL,CL		;COL TO DL
	MOV	CX,0
	MOV	BX,0		;PAGE 0
	MOV	AH,2		;FUNCTION FOR CURSOR POSITIONING
	INT	16		;CALL VIDEO I/O
	POP	BP
	RET
CURPOS	ENDP
;This function returns a pointer to a string, filled with a specified number
;of the same character.  The arguments passed to this function are a character,
;and an integer.
;usage: char *string(c, num);
;	char c; int num;
string	proc near
	push	bp
	mov	bp,sp
	mov	di,offset str		;point to the string
	mov	al,[bp + 4]		;get the fill character
	mov	cx,[bp + 6]		;get the length
	sub	ch,ch			;get rid of upper half
rep	stosb				;save the characters in the string
	mov	byte ptr es:[di],0	;put in a null terminator
	mov	ax,offset str		;return a pointer to the string
	pop	bp
	ret
string endp
;function to do a fast string copy. usage: stcpy(to, from);
;				           char *to, *from;
stcpy	proc near
	push	bp
	mov	bp,sp
	mov	di,[bp + 4]		;get the destination pointer
	mov	si,[bp + 6]		;get the source pointer
	push	di			;save the destination pointer
	mov	di,si			;get the source pointer
	mov	cx,0ffffh		;put max. string length in counter
	mov	al,0			;null terminator
repne	scasb				;look for the null terminator
	not	cx			;get the string length (with null)
	pop	di			;recover the destination pointer
rep	movsb				;copy the source to the destination
	pop	bp
	ret
stcpy endp
;fast function to get length of a string. usage: len = stlen(ptr);
;						 char *ptr; int len;
stlen	proc near
	push	bp
	mov	bp,sp
	mov	di,[bp + 4]		;get the destination pointer
	mov	cx,0ffffh		;put max. string length in counter
	mov	al,0			;null terminator
repne	scasb				;look for the null terminator
	inc	cx			;adjust for null
	not	cx			;get the string length (without null)
	mov	ax,cx			;return the string length
	pop	bp
	ret
stlen endp
;fast string concatenate. usage: stcat(to, from);
;				 char *to, *from;
stcat	proc near
	push	bp
	mov	bp,sp
	mov	di,[bp + 4]		;get the destination pointer
	mov	si,[bp + 6]		;get the source pointer
	mov	cx,0ffffh		;put max. string length in counter
	mov	al,0			;null terminator
repne	scasb				;look for the null terminator
	dec	di			;point to the null terminator
	push	si			;save the source parameter
	push	di			;save the destination parameter
	call	stcpy			;copy source to destination
	mov	sp,bp			;restore the stack pointer
	pop	bp
	ret
stcat endp
;THE FOLLOWING FUNCTION, *ndx(dest, pattern), RETURNS A POINTER TO THE
;FIRST OCCURRENCE OF 'pattern' IN 'dest'.  IF THE PATTERN IS NOT FOUND,
;THE FUNCTION RETURNS -1.
ndx	proc near
	push	bp
	mov	bp,sp
	mov	di,[bp + 4]		;get the destination pointer
	mov	cx,0ffffh		;put max. string length in counter
	mov	al,0			;null terminator
	cld
repne	scasb				;look for the null terminator
	inc	cx			;adjust for null
	not	cx			;get the string length (without null)
	mov	dx,cx			;save dest lngth in dx
	mov	di,[bp + 6]		;get the pattern pointer
	mov	cx,0ffffh
	mov	al,0
	cld
repne	scasb
	inc 	cx
	not	cx			;get length of pattern into cx
	mov	bx,cx			;save it in bx
_ha:	mov	di,[bp + 4]		;get the destination pointer
	mov	si,[bp + 6]		;get the pattern pointer
	cld
	repe	cmpsb			;compare strings
	jne	__nope			;not equal, look some more
	mov	ax,[bp + 4]		;if equal, return ptr to location
	jmp	__eqe
__nope:	mov	ax,[bp + 4]		;get pointer from stack
	inc	ax			;increment the dest ptr
	mov	[bp + 4],ax		;restore dest pointer
	dec	dx			;decrement the length of dest string
	mov	ax,dx			;get length into ax for compare
	cmp	ax,bx			;if len dest < pattern, no match
	jb	__no
	mov	cx,bx			;put length of pattern in cx
	jmp	_ha			;keep on trucking
__no:	mov	ax,-1			;return EOF if cant find pattern
__eqe:	mov	sp,bp	
	pop	bp
	ret
ndx	endp
PROG	ENDS
END
