

/* GEM demonstrations from the 'C' programming lanuage */
/* Written using the Metacomco Lattice C compiler */
/* By Steve Pedler for Page 6 Magazine, England */
/* Version 0.2   March 13 1987 */

/* Lattice include files */

#include "stdio.h"
#include "osbind.h"

/* ----------------- declarations, constants -------------------------*/
#define WORD short int
#define SOLID 1




char      resalert[]="[3][ Use only low resolution | when running this program ][ OK ]",
          hello_box[]="[1][ Demonstrations of GEM in 'C' | by Steve Pedler | for Page 6 Magazine 1987 ][ OK ]";

WORD      contrl[ 12 ], intin[ 256 ], ptsin[ 256 ],
          intout[ 256 ], ptsout[ 256],
          work_handle, dum, temp_col, old_pal[ 16 ], new_pal[ 16 ],
          button,
          col_index[]={ 0, 2, 3, 6, 4, 7, 5, 8, 9, 10, 11, 14, 12, 15, 13, 1 },
          demo1();

int       finished;


/* ------------------- program starts here ---------------------------*/
main()
{
          WORD c;

          init_gem();
          while( finished !=0 ){
               c=demo1();
               if( c==3 ) {
                    finished=0; break;
               }
          }
          finish_gem();
}

/* ------------------- initialisation ---------------------------------*/
init_gem()
{
          int i;
          WORD resol;

          finished=1;
          appl_init();        /* initialise GEM */
          work_handle=graf_handle( &dum, &dum, &dum, &dum );   /* get the device handle */
          for( i=1; i<10; ++i ) 
               intin[ i ]=1;
          intin[ 10 ]=2;
          v_opnvwk( intin, &work_handle, intout );     /* open workstation */
          for( i=0; i<16; old_pal[ i ]=Setcolor( i++, -1 ));
          for( i=0; i<16; ++i )
               new_pal[ i ]=old_pal[ i ];
          resol=Getrez();
          if( resol>0 ){
               form_alert( 1, resalert );
               finished=0;
          } else {
               form_alert( 1, hello_box );
          }
}

/* --------------- demonstration #1 -----------------------------------*/
/* draw a circle in quadrants and animate by colour rotation */
WORD demo1()
{
          int  delay, count, step, i;
          WORD starta, stopa, a, c;

          Setpallete( new_pal );
          v_hide_c( work_handle );
          v_clrwk( work_handle );
          vsf_interior( work_handle, SOLID );
          starta=0;
          stopa=200;
          for( i=0; i<3; ++i ){
               for( a=1; a<7; a++ ){
                    vsf_color( work_handle, col_index[ a ] );
                    v_pieslice( work_handle, 160, 100, 80, starta, stopa );
                    starta=starta+200; 
                    stopa=stopa+200;
               }
          }
          vst_height( work_handle, 6, &dum, &dum, &dum, &dum );
          v_gtext( work_handle, 8, 185, "Demo 1 - Spinning disc" );
          c=0;
          count=5000;
          step=100;
          while( c<2 ){
               temp_col=new_pal[ 6 ];
               for( a=5; a>0; a-- ){
                    new_pal[ a+1 ]=new_pal[ a ];
               }
               new_pal[ 1 ]=temp_col;
               Setpallete( new_pal );
               for( delay=1; delay<count; ++delay )
                    ;    /* don't miss this semicolon! */
               graf_mkstate( &dum, &dum, &button, &dum );
               if( button==1 ) {
                    count=count+step;
                    if( count>30000 || count<300 ){ step=step * -1;
                         count=count+step;
                    }
               }   

               if( button>1 ) c=button;
          }
          return( c );
}

/* -------------- exit the GEM application ----------------------------*/
finish_gem()
{
          WORD reset;
          reset=0;
          v_show_c( work_handle, reset);
          Setpallete( old_pal );
          v_clsvwk( work_handle );
          appl_exit();
}

