;DiskPark by Simcha Lerner

;Hard disk power off prog
;moves head to max cyl, beeps, then halts system
	

;  DiskPark by Simcha Lerner
;  Version 1.00, November 1984
;  
;  This program is a utility that will  locate all hard disks in the system
;  and move  their heads to the  inner-most cylinder.  It will  give status
;  messages for  each drive encountered.   This program uses the  hard disk
;  ROM BIOS calls  as documented in the  IBM Tech Ref for the  XT. This has
;  been tested on a  Compaq Plus without any problems.  It  will work on PC
;  compatible  machines and  non-IBM  hard  disks only  if  they are  fully
;  compatible at the BIOS level.  All other  I/O is through DOS so that you
;  can use this via a re-directed console.
;  
;  The ability to exit back to DOS is  to allow you to park the disk if you
;  are going to leave the machine for  a while.  EXITING TO DOS CAN UN-PARK
;  THE HARD DISK, SO DO NOT EXIT TO  DOS IF YOU ARE ABOUT TO POWER OFF YOUR
;  MACHINE.   In order  to exit  back to  DOS, hit  three carriage  returns
;  slowly.  The program  flushes the buffer before each  character to avoid
;  accidental activation.
;  
;****************************************************************************
;*                                                                          *
;* IMPORTANT:                                                               *
;*                                                                          *
;* This  program does  NOT lock  the  heads.  If  you intend  to move  your *
;* system, run the utility that came with it for that purpose.              *
;*                                                                          *
;****************************************************************************



stack	segment	para stack 'stack'

	db 64 dup ('stack')

stack	ends

work	segment para public 'work'

retry	db	?			;retry counter
maxdisk	db	?			;number of hard disks in system (1-8)
maxcyl	dw	?			;of current drive
curdisk db	0			;current disk number (0-7)

enter	db	13,25 dup (10),'DiskPark for the IBM PC/XT, by Simcha Lerner, version 1.00',13,10,'$'
message db	13,10,'Hard disk '	;normal message
drvnum	db	?
	db 	' parked.',13,10,7,'$'
errmsg	db	13,10,'No hard disk found?',7,13,10,'$' 

abortmsg db	13,10,'Error parking hard disk '
baddrv	db	?
	db	', operation aborted.',7,13,10,'$'

endmsg	db	13,10,'DiskPark is done.',13,10,10
db	'Power off your system or enter three CR',39,'s to return to DOS',13,10,'$'

public retry				;publics generate symbols for
public maxdisk				;use in debuger, they are not
public curdisk				;realy needed
public message
public drvnum
public errmsg
public abortmsg
public baddrv
public maxcyl


work	ends


cseg	segment para public 'code'
public  start
start	proc far
	assume cs:cseg,ds:work,ss:stack

	mov	ax,work		;set ds to proper value
	mov	ds,ax

;give intro
	mov	dx,offset enter	;set pointer
	mov	ah,9		;use dos print string
	int	21h		;do it

;get hard disk params.
	mov	ax,0801h	;request for disk params
	mov	dl,80h		;set valid drive so control doesn't go
				;to floppy BIOS via int 40h
	int	13h		;do it
	jc	error		;quit pgm if error here

;save them for later use
	mov	maxdisk,dl	;save number of disks to park
	mov	maxcyl,cx	;this is maxcyl for drive 0
	or	dl,dl		;test for dl=0 (no hard disk)
	jnz	noerror		;will first do park routine for drive 0

;aborts program execution w/ error message
error:	mov	dx,offset errmsg 
	mov	ah,9		;dos print string
	int	21h		;call dos
	mov	ax,4cffh	;terminate with error code 255
	int	21h		;do it

;do seek to proper cyl
noerror:
	mov	al,3		;will retry two times
	mov	retry,al	;set retry count

again:	mov	dl,curdisk	;set paramaters. first, get current disk (0-7)
	add	dl,80h		;add 80h to make it a hard disk number
	mov	dh,0		;head number
	mov	cx,maxcyl	;set cyl (also sector, but we don't care)
	mov	ax,0c01h	;set seek operation
	int	13h		;do it
	jnc	goodseek	;all is well that ends well...

;we had an error, reset, recal, and try again
	mov	al,retry	;retriev retry count
	dec	al		;decrement
	mov	retry,al	;save it
	jz	abort		;if retry count expired, abort for this drive

;will retry, so set up paramaters to reset the drive
	mov	dl,curdisk	;current drive number (0-7)
	add	dl,80h		;make it a hard disk
	mov	dh,0		;head number
	mov	ax,0		;reset command
	push	dx		;save drive number
	int	13h		;reset drv

;now set up paramaters to recal the drive
	pop	dx		;get drive number
	jc	abort		;if error from reset, abort for this drive
	mov	ax,1100h	;recal command
	int	13h		;do the recal
	jnc	again		;if no error, try seek again

;give up for this drive w/ error message
abort:	mov	al,curdisk	;get drive number of troublemaker
	add	al,31h		;make it ascii char
	mov	baddrv,al	;put it in message
	mov	dx,offset abortmsg ;output message via DOS
	mov	ah,9
	int	21h		;print bad message
	jmp	next		;try next drive (if any)

;no error on the seek, let then know that it is parked
goodseek:
	mov	al,curdisk	;get drive number
	add	al,31h		;change to ascii char (1-8)
	mov	drvnum,al	;put it in the message
	mov	dx,offset message ;print message via dos
	mov	ah,9
	int	21h		;fall thru to next: and do next drive (if any)

;see if there are any more hard disks to park (you should be so lucky)
next:
	mov	al,curdisk	;which drive did we do last?
	inc	al		;next!
	cmp	al,maxdisk	;curdisk is 0-7 and max is 1-8 finish if equal
	jae	done		;this could be a je, but lets be safe
	mov	curdisk,al	;save incremented value as current

;set paramaters and then request disk maxcyl for this drive
	mov	dl,al		;current drive number
	add	dl,80h		;make it a hard disk
	mov	ax,800h		;drive paramater command
	int	13h		;do it
	jc	abort		;abort w/ message and try next drive (if any)
	mov	maxcyl,cx	;no error-save maxcyl (already have max drive)
	jmp	noerror


;give msg, flush input buffer and wait for three cr's to return to dos
;  (we don't expect to get them, he should power off)

done:	mov	dx,offset endmsg ;set pointer
	mov	ah,9		;use dos print string
	int	21h		;do it

;flush buffer and wait
;will re-use retry to count the number of cr's

	mov	al,3
	mov	retry,al
flush:	mov	ax,0c07h	;flush buffer and direct input char w/o echo
	int	21h
	cmp	al,13		;is it a cr
	jne	flush		;it wasn't, reflush and do again
	mov	al,retry	;get count
	dec	al		;decrement
	mov	retry,al	;save it
	jnz	flush		;not done, get some more
	mov	ax,4cfeh	;return to dos w/ error 254
	int	21h		;bye bye
	
;publics are not needed, they are to facilitate symbolic debugging 
public error
public noerror
public again
public abort
public goodseek
public next
public done

start	endp
cseg	ends
	end	start




