# Template file for the C programming language
# symbols used to separate program words
# It is important to place compound delimiters before individual
# characters which occur in them.

DELIMITERS:  # comments may be placed here
             # or here

, . ; : ? ' " ( ) [ ] { } >>= <<= >> << >= <= < > != == += -= /= *=
|= &= ^= %= ++ -- || && /* */ ^ = + - * | & %

# The above blank line signals the end of the delimiter section.

COMMENTS:  # place opening and closing comment symbols here
           # opening comment followed by a '-' turns off formatting
           # opening comment followed by a '+' turns on  formatting

/*  */     # comment symbols must occur in pairs

BLOCKS:    # blocks are symbols which change indentation
           # 1 indicates change the indentation on the same line
           # 2 indicates change the indentation on the next line
           # 3 indicates change the indentation on current and next line
           # block words/symbols must be in KEYWORDS list for formatting
{ 2 } 1    # make sure indentation is balanced for each pair

KEYWORDS:  # tokens that trigger format changes
           # cr = carriage return before and after word
           # ca = carriage return after word
           # cb = carriage return before word
           # >  = indent next line one extra indentation
           # <  = reduce indentation of current line one indentation

{       cr
}       cr
if       >
else     >
case     <
break    <

GENERAL:   # general formatting controls
           #
co lc 78   # co = comments,
           # uc = upper case, lc = lower case
           # <number> = last column of right comment symbol
al = 15 /* 50 */ 50   # al = align symbols
                      # format: <symbol> <distance>
                      # the symbol can be any length but no spaces
                      # distance is the column distance to scan in
                      # previous line on either side of symbol
ai 2       # ai = autoindent, columns to change indentation
lm 0       # lm = left margin, must be >= 0

# dc  disable comments ( not available in PD version )
# ds  disable scrolling ( not available in PD version )
# da  disable alignment ( not available in PD version )
